=== doc/requirements.txt ===
myst-parser
sphinx~=4.3.0
breathe
sphinx-rtd-theme
sphinxcontrib-mermaid
