=== debian/changelog ===
ismrmrd (1.8.0-2build8) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:07:34 +0200

ismrmrd (1.8.0-2build7) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:57:12 +0200

ismrmrd (1.8.0-2build6) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Miriam España Acebal <miriam.espana@canonical.com>  Sun, 26 Jan 2025 10:57:24 +0000

ismrmrd (1.8.0-2build5) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:23:33 +0100

ismrmrd (1.8.0-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:25:52 +0000

ismrmrd (1.8.0-2build3) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:58:27 +0000

ismrmrd (1.8.0-2build2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:50:45 +0100

ismrmrd (1.8.0-2build1) mantic; urgency=medium

  * No-change rebuild against glibc 2.38-1ubuntu2

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 11 Aug 2023 12:32:57 +0200

ismrmrd (1.8.0-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Mon, 02 May 2022 13:51:48 +0200

ismrmrd (1.8.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Bump SONAME again
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Andreas Tille <tille@debian.org>  Sun, 10 Apr 2022 20:44:57 +0200

ismrmrd (1.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * watch file standard 4 (routine-update)
  * Build-Depends: libboost-random-dev
  * Bump SONAME
  * debian/not-installed mentioning matlab files
  * review copyright

 -- Andreas Tille <tille@debian.org>  Mon, 21 Mar 2022 20:12:39 +0100
