## ismrmrd 1.14.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.21)
 foreach(p
     CMP0025 # CMake 3.0 Compiler id for Apple Clang is now ``AppleClang``.
     CMP0042 # CMake 3.0 ``MACOSX_RPATH`` is enabled by default.
@@ -18,8 +18,8 @@
   "Location of CMake scripts")
 
 # command line options
-option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)
 option(USE_HDF5_DATASET_SUPPORT "Compile with support for reading and writing datasets to HDF5 files" ON)
+option(BUILD_STATIC "Build static library" OFF)
 option(BUILD_TESTS "Build unit tests " ON)
 option(BUILD_UTILITIES "Build utilities tests " ON)
 option(BUILD_EXAMPLES "Build examples tests " ON)
@@ -39,11 +39,23 @@
 endif()
 
 # compiler flags
+if(NOT "${CMAKE_CXX_STANDARD}")
+  set(CMAKE_CXX_STANDARD 11)
+else()
+  message(STATUS "CMAKE_CXX_STANDARD set externally to ${CMAKE_CXX_STANDARD}")
+endif()
+
+set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)
+
 if (WIN32)
-    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS)
+    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS -DBOOST_UUID_FORCE_AUTO_LINK)
     add_definitions(-DUNICODE -D_UNICODE)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
+
+    # https://devblogs.microsoft.com/cppblog/msvc-now-correctly-reports-__cplusplus/
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
+
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
     set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
     set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
@@ -63,10 +75,10 @@
     set(Boost_NO_SYSTEM_PATHS       "TRUE")
     set(HDF5_USE_STATIC_LIBRARIES   "yes")
     set(CMAKE_C_FLAGS               "${CMAKE_C_FLAGS} -std=c99 -Wall")
-    set(CMAKE_CXX_FLAGS             "${CMAKE_CXX_FLAGS} -w -std=c++11 -D_GLIBCXX_USE_CXX11_ABI=0")
+    set(CMAKE_CXX_FLAGS             "${CMAKE_CXX_FLAGS} -w -D_GLIBCXX_USE_CXX11_ABI=0")
 else ()
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -Werror")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11 -Werror")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
 endif ()
 
 #  ---   VERSIONING  (begin) ----
@@ -80,12 +92,30 @@
 #in the utility libraries, that don't affect the data format itself.
 # For more information see http://semver.org/
 set(ISMRMRD_VERSION_MAJOR 1)
-set(ISMRMRD_VERSION_MINOR 8)
-set(ISMRMRD_VERSION_PATCH 0)
+set(ISMRMRD_VERSION_MINOR 14)
+set(ISMRMRD_VERSION_PATCH 3)
+
 set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
 set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})
 
-set(ISMRMRD_XML_SCHEMA_SHA1 "5464ea590ded027471b0740bba7472c4919b895b")
+if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
+file(READ ${CMAKE_CURRENT_SOURCE_DIR}/vcpkg.json VCPKG_JSON)
+string(JSON VCPKG_VERSION_STRING GET ${VCPKG_JSON} version)
+
+if (NOT VCPKG_VERSION_STRING STREQUAL ISMRMRD_VERSION_STRING)
+    message("")
+    message("-----------------------------------------------")
+    message("            !! VCPKG VERSION ERROR!!           ")
+    message(" Vcpkg version in vcpkg.json must match ISMRMRD")
+    message("           version in CMakeLists.txt           ")
+    message("-----------------------------------------------")
+    message("")
+    message(FATAL_ERROR "     FATAL VCPKG VERSION ERROR")
+endif ()
+
+endif()
+
+set(ISMRMRD_XML_SCHEMA_SHA1  "40036f175a77542b50acbcfb0f019094c90b5e18")
 
 #Remove line breaks and white space that does not change the meaning of the schema
 file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file
@@ -121,24 +151,37 @@
   message(FATAL_ERROR "     FATAL XML VERSION ERROR")
 endif()
 
+# Find static libraries only if linking statically
+if (BUILD_STATIC)
+    set(Boost_USE_STATIC_LIBS On)
+    set(HDF5_USE_STATIC_LIBRARIES TRUE)
+    set(FFTW_USE_STATIC_LIBS TRUE)
+else()
+    add_definitions(-DBOOST_TEST_DYN_LINK)
+endif()
+
+# Find Boost for tests and utilities
+find_package(Boost COMPONENTS filesystem random program_options unit_test_framework)
+find_package(pugixml CONFIG REQUIRED)
+find_package(FFTW COMPONENTS FLOAT_LIB)
 
 # Find HDF5 for dataset support
-
-
 if (USE_HDF5_DATASET_SUPPORT)
     if (VCPKG_TARGET_TRIPLET) #VCPKG HDF5 is packaged differently.
-        find_package(HDF5 CONFIG COMPONENTS C shared REQUIRED)
-        set(HDF5_C_LIBRARIES hdf5::hdf5-shared)
+        find_package(HDF5 CONFIG COMPONENTS C REQUIRED)
+        if (BUILD_STATIC)
+          set(ISMRMRD_DATASET_LIBRARIES hdf5::hdf5-static)
+        else()
+          set(ISMRMRD_DATASET_LIBRARIES hdf5::hdf5-shared)
+        endif()
     else ()
         find_package(HDF5 COMPONENTS C REQUIRED)
+        set(ISMRMRD_DATASET_LIBRARIES HDF5::HDF5)
     endif ()
     set(ISMRMRD_DATASET_SUPPORT true)
     set(ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
-    set(ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
-    set(ISMRMRD_DATASET_LIBRARIES ${HDF5_C_LIBRARIES})
     message(STATUS "HDF5 include found at: ${HDF5_INCLUDE_DIRS}")
     message(STATUS "HDF5 libs found at: ${HDF5_C_LIBRARIES}")
-
 else ()
     set(ISMRMRD_DATASET_SUPPORT false)
     message(WARNING " Dataset and file support unavailable!")
@@ -163,11 +206,9 @@
 # note: for the utilities in this project that need ismrmrd/version.h
 # remember to add ${CMAKE_BINARY_DIR}/include to the include path
 
-
 #  ---   VERSIONING  (end) ----
 
 #  ---   Main Library  (begin) ----
-# in windows, install the HDF5 dependencies
 
 # include directories for main library
 set(ISMRMRD_TARGET_INCLUDE_DIRS
@@ -182,6 +223,7 @@
   libsrc/ismrmrd.cpp
   libsrc/xml.cpp
   libsrc/meta.cpp
+  libsrc/serialization.cpp
   libsrc/waveform.cpp
   libsrc/waveform.c
   ${ISMRMRD_DATASET_SOURCES}
@@ -189,46 +231,47 @@
 
 set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})
 
-# optional handling of system-installed pugixml
-if (USE_SYSTEM_PUGIXML)
-
-    if (VCPKG_TARGET_TRIPLET) #VCPKG .
-        find_package(PugiXML CONFIG REQUIRED)
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS pugixml)
-    else ()
-        find_package(PugiXML REQUIRED)
-
-        message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
-        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-    endif ()
-else ()
-    list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
-endif ()
-
 if (build4GE)
    list(APPEND ISMRMRD_TARGET_LINK_LIBS pthread z dl)
 endif ()
 
+
 # main library
-add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
+if (BUILD_STATIC)
+  if (WIN32)
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+  endif()
+  set(ISMRMRD_PUGIXML_LIBRARIES pugixml::static)
+  add_library(ismrmrd STATIC ${ISMRMRD_TARGET_SOURCES})
+else()
+  set(ISMRMRD_PUGIXML_LIBRARIES pugixml::shared)
+  add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
+endif()
+
+list(APPEND ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_PUGIXML_LIBRARIES})
+
 target_include_directories(ismrmrd PUBLIC ${ISMRMRD_TARGET_INCLUDE_DIRS})
 if (USE_HDF5_DATASET_SUPPORT)
   target_compile_options(ismrmrd PUBLIC ${HDF5_DEFINITIONS})
 endif()
+
 add_library(ismrmrd::ismrmrd ALIAS ismrmrd)
-set_target_properties(ismrmrd PROPERTIES
-  VERSION ${ISMRMRD_VERSION_STRING}
-  SOVERSION ${ISMRMRD_SOVERSION}
+
+target_compile_definitions(
+    ismrmrd
+    PUBLIC $<$<CONFIG:Debug>:ISMRMRD_DEBUG>
+    INTERFACE $<$<NOT:$<BOOL:${BUILD_STATIC}>>:ISMRMRD_IMPORT>
+    PRIVATE $<$<CXX_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS>
 )
 
 set_target_properties(ismrmrd
   PROPERTIES
-  EXPORT_NAME ISMRMRD)
-
-target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
+  DEFINE_SYMBOL ISMRMRD_EXPORT
+  EXPORT_NAME ISMRMRD
+  VERSION ${ISMRMRD_VERSION_STRING}
+  SOVERSION ${ISMRMRD_SOVERSION})
+
+target_link_libraries(ismrmrd PUBLIC ${ISMRMRD_TARGET_LINK_LIBS})
 list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
 list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libraries
 
@@ -238,7 +281,7 @@
 install(TARGETS ismrmrd EXPORT ISMRMRDTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} 
+   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT Devel
 )
 
@@ -256,7 +299,6 @@
 if (BUILD_UTILITIES)
   add_subdirectory(utilities)
 endif()
-
 
 if (HDF5_FOUND AND BUILD_EXAMPLES)
     add_subdirectory(examples/c)
@@ -265,6 +307,7 @@
 # TODO: make this work on Windows
 if (BUILD_TESTS)
    if (NOT build4GE)
+       enable_testing()
       add_subdirectory(tests)
    endif ()
 endif ()
@@ -276,40 +319,3 @@
 #
 
 include(CMakePackageConfigHelpers)
-set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/ISMRMRD)
-
-set(CONFIG_ISMRMRD_SCHEMA_DIR   ${ISMRMRD_SCHEMA_DIR})
-set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${ISMRMRD_TARGET_INCLUDE_DIRS})
-set(CONFIG_ISMRMRD_LIBRARY_DIRS ${ISMRMRD_LIBRARY_DIRS})
-configure_file(cmake/ISMRMRDConfig.cmake.in
-  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfig.cmake"
-  @ONLY
-)
-
-set(CONFIG_ISMRMRD_SCHEMA_DIR   ${CMAKE_INSTALL_PREFIX}/share/ismrmrd/schema)
-set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include)
-set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
-if (ISMRMRD_DATASET_SUPPORT)
-  list(APPEND CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
-endif ()
-
-configure_package_config_file(cmake/ISMRMRDConfig.cmake.in
-  "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
-  INSTALL_DESTINATION ${INSTALL_CONFIGDIR})
-
-write_basic_package_version_file(
-  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
-  VERSION ${ISMRMRD_VERSION_STRING}
-  COMPATIBILITY SameMajorVersion
-  )
-
-# Write a CMake file with all the targets information
-# (not for installing, but for external project to import targets from the
-#  current build tree)
-if(CMAKE_VERSION VERSION_LESS 3.0)
-  export(TARGETS ismrmrd
-    FILE ${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake
-    NAMESPACE ISMRMRD::
-    )
-else()
-  export(EXPORT ISMRMRDTargets
