=== doc/requirements.txt ===
myst-parser
sphinx==6.2.1
breathe
sphinx-rtd-theme
sphinxcontrib-mermaid
