=== examples/c/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.21)
 project(ISMRMRD-C-EXAMPLE)
 
 # if building this example as a standalone project
