=== debian/changelog ===
ismrmrd (1.14.3-1) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113055
  * d/watch: version=5
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Build-Depends: libboost-filesystem-dev
  * Soname bump to 1.14
  * Install all binaries
  * d/copyright: review
  * Lintian-overrides: update

 -- Andreas Tille <tille@debian.org>  Sat, 18 Oct 2025 16:35:35 +0200
