=== debian/control ===
--- 
+++ 
@@ -1,33 +1,41 @@
 Source: ismrmrd
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Standards-Version: 4.7.2
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders:
+ Ghislain Antony Vaillant <ghisvail@gmail.com>,
 Section: science
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               d-shlibs,
-               libboost-program-options-dev,
-               libboost-random-dev,
-               libboost-test-dev,
-               libfftw3-dev,
-               libhdf5-dev,
-               libpugixml-dev
-Build-Depends-Indep: doxygen
-Standards-Version: 4.6.0
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ d-shlibs,
+ libboost-filesystem-dev,
+ libboost-program-options-dev,
+ libboost-random-dev,
+ libboost-test-dev,
+ libfftw3-dev,
+ libhdf5-dev,
+ libpugixml-dev,
+Build-Depends-Indep:
+ doxygen,
 Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
 Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
 Homepage: https://ismrmrd.github.io/
 Rules-Requires-Root: no
 
-Package: libismrmrd1.8
+Package: libismrmrd1.14
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
-Breaks: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
-Replaces: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Breaks:
+ libismrmrd1.7,
+ libismrmrd1.8,
+Replaces:
+ libismrmrd1.7,
+ libismrmrd1.8,
 Description: ISMRM Raw Data format (ISMRMRD)
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -43,11 +51,13 @@
 Package: libismrmrd-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends},
-         libhdf5-dev,
-         libpugixml-dev,
-         libismrmrd1.8 (= ${binary:Version})
-Suggests: libismrmrd-doc
+Depends:
+ ${misc:Depends},
+ libhdf5-dev,
+ libpugixml-dev,
+ libismrmrd1.14 (= ${binary:Version}),
+Suggests:
+ libismrmrd-doc,
 Description: development files for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -64,7 +74,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: documentation for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -81,9 +92,10 @@
 Architecture: any
 Multi-Arch: foreign
 Section: utils
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         ismrmrd-schema
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+ ismrmrd-schema,
 Description: command-line tools for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -100,7 +112,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: misc
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: schema for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
