=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+export LC_ALL=en_US.UTF-8
 
 # Hardening flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -13,7 +15,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON
+	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_auto_build-indep:
 	dh_auto_build -- apidoc
