=== debian/watch ===
Version: 5

Template: Github
Owner: ismrmrd
Project: ismrmrd
